//  "BMP" Copyright (C) 2003-2007 BMP development
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License Version 2
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_BOOKMARK_HANDLER_HH
#define BMP_BOOKMARK_HANDLER_HH

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif //HAVE_CONFIG_H

#include <glibmm/ustring.h>

using namespace Glib;

namespace Bmp
{
    class BookmarkHandler
    {
      public:

        BookmarkHandler () {}
        virtual ~BookmarkHandler () {}

        virtual bool 
        get_bookmark (ustring const& id, /* the id to be used as the hostname part, but otherwise ignored */
                      ustring & url,
                      ustring & title) = 0; 
    
        virtual bool 
        set_bookmark (ustring const& url) = 0;

      protected:

    }; // end class BookmarkHandler 
} // end namespace Bmp 
  
#endif
