//  BMP
//  Copyright (C) 2005-2007 BMP development.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License Version 2
//  as published by the Free Software Foundation.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_STOCK_HH
#define BMP_STOCK_HH

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif //HAVE_CONFIG_H

// Stock icons
#  define BMP_STOCK_ABOUT           "bmp-stock-about"
#  define BMP_STOCK_ADD             "bmp-stock-add"
#  define BMP_STOCK_APPROVE         "bmp-stock-approve"
#  define BMP_STOCK_APPROVE_PARTIAL "bmp-stock-approve-partial"
#  define BMP_STOCK_ARTIST          "bmp-stock-artist-icon"
#  define BMP_STOCK_ARTIST_MB       "bmp-stock-artist-mb-icon"
#  define BMP_STOCK_ARTIST_ALL      "bmp-stock-artist-all-icon"
#  define BMP_STOCK_ARTIST_MULTIPLE "bmp-stock-artist-multiple-icon"
#  define BMP_STOCK_AUDIO           "bmp-stock-audio"
#  define BMP_STOCK_CDDA            "bmp-stock-cdda"
#  define BMP_STOCK_DELETE          "bmp-stock-delete"
#  define BMP_STOCK_DISK            "bmp-stock-disk"
#  define BMP_STOCK_DOWNLOAD        "bmp-stock-download"
#  define BMP_STOCK_ENTRY_CLEAR     "bmp-stock-entry-clear"
#  define BMP_STOCK_EDIT_ALBUM      "bmp-stock-edit-album"
#  define BMP_STOCK_EQ              "bmp-stock-equalizer"
#  define BMP_STOCK_EEK             "bmp-stock-eek"
#  define BMP_STOCK_ERROR           "bmp-stock-error"
#  define BMP_STOCK_FEED            "bmp-stock-feed"
#  define BMP_STOCK_FEED_ADD        "bmp-stock-feed-add"
#  define BMP_STOCK_FEED_DELETE     "bmp-stock-feed-delete"
#  define BMP_STOCK_FEED_UPDATE     "bmp-stock-feed-update"
#  define BMP_STOCK_FOLDER          "bmp-stock-folder"
#  define BMP_STOCK_HARDDISK        "bmp-stock-harddisk"
#  define BMP_STOCK_HTML_LINK       "bmp-stock-html-link"
#  define BMP_STOCK_JAMENDO         "bmp-stock-jamendo"
#  define BMP_STOCK_LASTFM_BAN      "bmp-stock-lastfm-ban"
#  define BMP_STOCK_LASTFM          "bmp-stock-lastfm"
#  define BMP_STOCK_LASTFM_LOVE     "bmp-stock-lastfm-love"
#  define BMP_STOCK_LASTFM_SKIP     "bmp-stock-lastfm-skip"
#  define BMP_STOCK_LIBRARY         "bmp-stock-library"
#  define BMP_STOCK_LIBRARY_TRACK   "bmp-stock-library-track"
#  define BMP_STOCK_LINK            "bmp-stock-link"
#  define BMP_STOCK_LYRICS          "bmp-stock-lyrics"
#  define BMP_STOCK_MUSICBRAINZ     "bmp-stock-musicbrainz"
#  define BMP_STOCK_NEW             "bmp-stock-new"
#  define BMP_STOCK_PLAY            "bmp-stock-play"
#  define BMP_STOCK_PLAYLIST        "bmp-stock-playlist"
#  define BMP_STOCK_PLUGIN          "bmp-stock-plugin"
#  define BMP_STOCK_PLUGIN_DISABLED "bmp-stock-plugin-disabled"
#  define BMP_STOCK_PREFERENCES     "bmp-stock-preferences"
#  define BMP_STOCK_REMOVE_MUSIC    "bmp-stock-remove-music"
#  define BMP_STOCK_SCAN            "bmp-stock-scan"
#  define BMP_STOCK_SEARCH          "bmp-stock-search"
#  define BMP_STOCK_SELECTED        "bmp-stock-selected"
#  define BMP_STOCK_TAG             "bmp-stock-tag"
#  define BMP_STOCK_TRACK           "bmp-stock-track"
#  define BMP_STOCK_UNDO            "bmp-stock-undo"
#  define BMP_STOCK_VIEW            "bmp-stock-view"
#  define BMP_STOCK_XIPH            "bmp-stock-xiph"

#  define BMP_STOCK_SHUFFLE         "bmp-stock-shuffle"
#  define BMP_STOCK_REPEAT          "bmp-stock-repeat"

#  define BMP_STOCK_ARTIST          "bmp-stock-artist-icon"
#  define BMP_STOCK_ARTIST_MB       "bmp-stock-artist-mb-icon"

#  define BMP_STOCK_OK      BMP_STOCK_APPROVE
#  define BMP_STOCK_YES     BMP_STOCK_APPROVE
#  define BMP_STOCK_NO      BMP_STOCK_ERROR

#  define BMP_THROBBER      "throbber.gif"

namespace Bmp
{
  void register_stock_icons ();
}

#endif //BMP_STOCK_HH
