//  BMP
//  Copyright (C) 2005-2007 BMP development.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  --
//
//  The BMPx project hereby grants permission for non-GPL compatible GStreamer
//  plugins to be used and distributed together with GStreamer and BMPx. This
//  permission is above and beyond the permissions granted by the GPL license
//  BMPx is covered by.

#ifndef BMP_UI_PART_BASE_HH 
#define BMP_UI_PART_BASE_HH

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtkmm/uimanager.h>
#include <libglademm/xml.h>

namespace Bmp
{
  namespace UiPart
  {
    class Base
    {

      public:

        Base (Glib::RefPtr<Gnome::Glade::Xml> const& xml,
              Glib::RefPtr<Gtk::UIManager>    const& ui_manager)
        : m_ref_xml     (xml)
        , m_ui_manager  (ui_manager) {}

        virtual ~Base () {}
        virtual guint add_ui () = 0;
        virtual guint add_context_ui () { return 0; }
        virtual guint add_tray_ui () { return 0; }

      protected:

        Glib::RefPtr<Gnome::Glade::Xml> m_ref_xml;
        Glib::RefPtr<Gtk::UIManager>    m_ui_manager;
        Glib::RefPtr<Gtk::ActionGroup>  m_actions;
    };
  }
}
#endif //!BMP_UI_PART_BASE_HH
